=== bin/CMakeLists.txt ===
install(PROGRAMS qtcreator.sh DESTINATION bin)
