=== tests/CMakeLists.txt ===
add_subdirectory(auto)
# add_subdirectory(manual)
# add_subdirectory(tools)
add_subdirectory(unit)
