=== debian/changelog ===
qtcreator (4.11.0-2build2) focal; urgency=medium

  * No-change rebuild against qtbase-abi-5-12-8.

 -- Rik Mills <rikmills@kde.org>  Fri, 10 Apr 2020 20:07:23 +0100

qtcreator (4.11.0-2build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:24:25 +0100

qtcreator (4.11.0-2) unstable; urgency=medium

  * Use Rules-Requires-Root: no.
  * Make qtcreator recommend clang-tidy, used in the Analyze menu.
  * Backport patch to detect compilers supported by ccache, if present.
  * Update Standards-Version to 4.5.0. No changes required.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Wed, 29 Jan 2020 14:48:28 -0300

qtcreator (4.11.0-1) unstable; urgency=medium

  [ Lisandro Damián Nicanor Pérez Meyer ]
  * New upstream release.
  * Update debian/copyright.
  * Refresh patches.
  * Bump Standards-Version to 4.4.1. No changes required.
  * Switch to using debhelper-compat as a build dependency.

  [ Patrick Franz ]
  * Added missing licence-texts in debian/copyright.
  * Fixed licence for metadata.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sat, 14 Dec 2019 12:08:19 -0300

qtcreator (4.10.2-2) unstable; urgency=medium

  * Use the system's KF5SyntaxHighlighting in order to avoid the embedded
    version.
  * Improve debian/copyright.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Mon, 02 Dec 2019 22:55:36 -0300

qtcreator (4.10.2-1) unstable; urgency=medium

  * New upstream release.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 19 Nov 2019 19:28:14 -0300

qtcreator (4.10.1-1) unstable; urgency=medium

  * New upstream release.
  * Remove ClangFormat-improve-the-message-the-users-see.patch, applied
    upstream.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Tue, 08 Oct 2019 22:52:53 -0300

qtcreator (4.10.0-2) unstable; urgency=medium

  * Add ClangFormat-improve-the-message-the-users-see.patch. In this way our
    users can know why the functionality is not there. We will surely not ask
    clang maintainers to patch it with a non-approved patch. This can be
    reconsidered if the patch gets accepted upstream. This is related to
    Debian bug #919860.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Thu, 12 Sep 2019 10:41:59 -0300

qtcreator (4.10.0-1) unstable; urgency=medium

  * New upstream release.
  * New changelog entry.
  * Refresh patches dealing with the clazy plugin.
  * Bump debhelper compatibility to 12.
  * Remove now useless lintian overrides.
  * Extend qtcreator-doc long description.
  * Bump Standards-Version to 4.4.0, no changes required.
  * Momentarily disable always_autotect_qt_versions patch, the code has
    changed and we need to check if it's really needed.
  * Switch to LLVM/Clang 8, as required by the source.
  * Force using qmake as build system. We now also hace CMake support. We
    should switch to it as soon as it's considered stable enough.
  * Refresh debian/copyright.

 -- Lisandro Damián Nicanor Pérez Meyer <lisandro@debian.org>  Sun, 08 Sep 2019 12:41:07 -0300
