=== debian/watch ===
version=3
opts="repack,compression=xz"
https://download.qt.io/official_releases/qtcreator/([\d\.]*)/([\d\.]*)/qt-creator-opensource-src-([^-]*)\.tar\.xz
